;  SAD     =$1740           6530 A DATA
;  PADD    =$1741           6530 A DATA DIRECTION
;  SBD     =$1742           6530 B DATA
;  PBDD    =$1743           6530 B DATA DIRECTION
;  CLK1T   =$1744           DIV BY 1 TIME
;  CLK8T   =$1745           DIV BY 8 TIME
;  CLK64T  =$1746           DIV BY 64 TIME
;  CLKKT   =$1747           DIV BY 1024 TIME
;  CLKRDI  =$1747           READ TIME OUT BIT
;  CLKRDT  =$1746           READ TIME




; KIM-1-Port A auf AVR-Port A mit DDR
; KIM-1-Port B in GPIOR1 ohne DDR nur Ausgang
;	Emulation 74145 auf Port B + Port C

READ_IO:
			; nur leerer Dummy, hier mssten die IO-Routinen rein
			; Adresse in YL
			;ret

			; kurze Anpassung an KIM-1 zu Sicherheit, falls doch ungltige Adressen
			;	angesprochen werden.

			subi YL, 0x40
			brsh RIO_1
			ret
		RIO_1:
			cpi YL, 0x07
			brlo RIO_2
			ret

		RIO_2:
			movw reg_PCL, ZL			; Z sichern
			ldi ZL, low (READ_IO_tab)
			ldi ZH, high(READ_IO_tab)
			add ZL, YL
			adc ZH, zero
			ijmp
			




WRITE_IO:
			; nur leerer Dummy, hier mssten die IO-Routinen rein
			; Adresse in YL
			;rjmp main_loop

			subi YL, 0x40
			brsh WIO_1
			ret
		WIO_1:
			cpi YL, 0x07
			brlo WIO_2
			ret

		WIO_2:
			movw reg_PCL, ZL			; Z sichern
			ldi ZL, low (WRITE_IO_tab)
			ldi ZH, high(WRITE_IO_tab)
			add ZL, YL
			adc ZH, zero
			ijmp



RIO_SAD:
			in oparand, DDRA
			movw ZL, reg_PCL
			ret
WIO_SAD:
			out DDRA, oparand
			movw ZL, reg_PCL
			rjmp main_loop

RIO_PADD:
			in oparand, PINA
			movw ZL, reg_PCL
			ret
WIO_PADD:
			out PORTA, oparand
			movw ZL, reg_PCL
			rjmp main_loop

RIO_SBD:
			in oparand, GPIOR1
			movw ZL, reg_PCL
			ret
WIO_SBD:
			out GPIOR1, oparand
			lsr oparand				; es werden bits 1-4 verwendet fr Tasten!!
			mov temp, oparand
			cpi temp, 0x09
			brlo WIO_SBD_1
			sbi PORTC, 0
			out PORTB, zero
			movw ZL, reg_PCL
			rjmp main_loop
		WIO_SBD_1:
			cbi PORTC, 0
			;tst oparand
			;breq WIO_SBD_2			; wenn 0
			ldi ZL, low (SBD_tab*2)
			ldi ZH, high(SBD_tab*2)
			add ZL, oparand
			adc ZH, zero
			lpm temp, Z
			out PORTB, temp
			movw ZL, reg_PCL
			rjmp main_loop

		WIO_SBD_2:
			out PORTB, zero
			movw ZL, reg_PCL
			rjmp main_loop

RIO_PBDD:
			; B erstmal nur aus, kein Eingang
			in oparand, GPIOR2
			movw ZL, reg_PCL
			ret
WIO_PBDD:
			out GPIOR2, oparand
			movw ZL, reg_PCL
			rjmp main_loop

RIO_CLK1T:
			clr oparand
			movw ZL, reg_PCL
			ret
WIO_CLK1T:
			movw ZL, reg_PCL
			rjmp main_loop

RIO_CLK8T:
			movw ZL, reg_PCL
			clr oparand
			ret
WIO_CLK8T:
			movw ZL, reg_PCL
			rjmp main_loop

RIO_CLK64T:
			movw ZL, reg_PCL
			clr oparand
			ret
WIO_CLK64T:
			movw ZL, reg_PCL
			rjmp main_loop

RIO_CLKKT:
			movw ZL, reg_PCL
			clr oparand
			ret
WIO_CLKKT:
			movw ZL, reg_PCL
			rjmp main_loop

RIO_CLKRDI:
			movw ZL, reg_PCL
			clr oparand
			ret
WIO_CLKRDI:
			movw ZL, reg_PCL
			rjmp main_loop

RIO_CLKRDT:
			movw ZL, reg_PCL
			clr oparand
			ret
WIO_CLKRDT:
			movw ZL, reg_PCL
			rjmp main_loop





READ_IO_tab:
			rjmp RIO_SAD
			rjmp RIO_PADD
			rjmp RIO_SBD
			rjmp RIO_PBDD
			rjmp RIO_CLK1T
			rjmp RIO_CLK8T
			rjmp RIO_CLK64T
			rjmp RIO_CLKKT
			rjmp RIO_CLKRDI
			rjmp RIO_CLKRDT

WRITE_IO_tab:
			rjmp WIO_SAD
			rjmp WIO_PADD
			rjmp WIO_SBD
			rjmp WIO_PBDD
			rjmp WIO_CLK1T
			rjmp WIO_CLK8T
			rjmp WIO_CLK64T
			rjmp WIO_CLKKT
			rjmp WIO_CLKRDI
			rjmp WIO_CLKRDT

SBD_tab:
			.db 0b00000001, 0b00000010
			.db 0b00000100, 0b00000000
			.db 0b00001000, 0b00010000
			.db 0b00100000, 0b01000000
			.db 0b10000000, 0b00000000























