;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************






opcode_LDA:


opcode_LDA_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2
		;16 + Main

	opc_LDA_1:
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop
			


opcode_LDA_ZP:
			;LoadZ opc_LDA_1
			;rjmp read_ZP
			movw ZL, reg_PCL		; Z wieder als PC

			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_ZP
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop



opcode_LDA_ZPX:
			;LoadZ opc_LDA_1
			;rjmp read_ZPX
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_ZPX
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_LDA_Abs:
			;LoadZ opc_LDA_1
			;rjmp read_Absolute
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_Absolute
			adiw SyncL, MHz
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_LDA_Abs_X:
			;LoadZ opc_LDA_1
			;rjmp read_Absolute_X	;2
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_Absolute_X
			adiw SyncL, MHz
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_LDA_Abs_Y:
			;LoadZ opc_LDA_1
			;rjmp read_Absolute_Y	;2
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero

			rcall read_Absolute_Y
			adiw SyncL, MHz
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_LDA_InX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero

			rcall read_InX
			adiw SyncL, MHz
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDA_InY:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero

			rcall read_InY
			adiw SyncL, MHz
			mov reg_A, oparand
			andi reg_Status, 0b11111001
			tst reg_A
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop



opcode_LDX:
opcode_LDX_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2

	opc_LDX_1:
			mov reg_X, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDX_ZP:
			movw ZL, reg_PCL		; Z wieder als PC

			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_ZP
			mov reg_X, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDX_ZPY:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero

			rcall read_ZPY
			mov reg_X, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_LDX_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_Absolute
			mov reg_X, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDX_Abs_Y:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_Y
			mov reg_X, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop







opcode_LDY:
opcode_LDY_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2

	opc_LDY_1:
			mov reg_Y, oparand
			andi reg_Status, 0b11111001
			tst reg_Y
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDY_ZP:
			movw ZL, reg_PCL		; Z wieder als PC

			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_ZP
			mov reg_Y, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDY_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero

			rcall read_ZPX
			mov reg_Y, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDY_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero


			rcall read_Absolute
			mov reg_Y, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_LDY_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_Y
			mov reg_X, oparand
			andi reg_Status, 0b11111001
			tst reg_X
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop







opcode_STA:

opcode_STA_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_A
			rjmp write_ZP

opcode_STA_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			;adiw SyncL, 4*MHz				; 
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_A
			rjmp write_ZPX

opcode_STA_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_A
			rjmp write_Absolute

opcode_STA_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_A
			rjmp write_Absolute_X

opcode_STA_Abs_Y:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_A
			rjmp write_Absolute_Y

opcode_STA_InX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_A
			rjmp write_InX

opcode_STA_InY:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_A
			rjmp write_InY



opcode_STX:

opcode_STX_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_X
			rjmp write_ZP

opcode_STX_ZPY:
			movw ZL, reg_PCL		; Z wieder als PC
			;adiw SyncL, 4*MHz				; 
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_X
			rjmp write_ZPY

opcode_STX_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_X
			rjmp write_Absolute





opcode_STY:

opcode_STY_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_Y
			rjmp write_ZP


opcode_STY_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			;adiw SyncL, 4*MHz				; 
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_Y
			rjmp write_ZPX


opcode_STY_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			mov oparand, reg_Y
			rjmp write_Absolute






















