;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************








opcode_ORA:

	opc_ORA_1:
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			movw ZL, reg_PCL		; Z wieder als PC
			rjmp main_loop

opcode_ORA_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_ORA_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_ORA_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_ORA_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_ORA_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_ORA_Abs_Y:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_Y
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_ORA_InX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InX
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_ORA_InY:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InY
			or reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop





opcode_AND:

	opc_AND_1:
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_AND_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop



opcode_AND_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_AND_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_AND_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_AND_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_AND_Abs_Y:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_Y
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_AND_InX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InX
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_AND_InY:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InY
			and reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop





opcode_EOR:

	opc_EOR_1:
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_EOR_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop



opcode_EOR_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_EOR_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_EOR_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_EOR_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_EOR_Abs_Y:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_Y
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_EOR_InX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InX
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop


opcode_EOR_InY:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InY
			eor reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop
















