;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************







opcode_ASL:

opcode_ASL_accu:
			movw ZL, reg_PCL		; Z wieder als PC
			adiw SyncL, 2*MHz				;2
			lsl reg_A
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop

opcode_ASL_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP


	opc_ASL_ZP_1:
			lsl oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_ZP

opcode_ASL_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX


opcode_ASL_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			andi reg_Status, 0b11111000


		opc_ASL_Abs_1:
			lsl oparand
			in temp, SREG
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_Absolute

opcode_ASL_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			andi reg_Status, 0b11111000
			lsl oparand
			in temp, SREG
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_Absolute




opcode_ROL:

opcode_ROL_accu:
			movw ZL, reg_PCL		; Z wieder als PC
			adiw SyncL, 2*MHz				;2
			lsr reg_Status
			rol reg_A
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_ROL_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP


	opc_ROL_ZP_1:
			lsr reg_Status
			rol oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_ZP

opcode_ROL_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX
			lsr reg_Status
			rol oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_ZP


opcode_ROL_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute

		opc_ROL_Abs_1:

			lsr reg_Status		; C-flag ins Carry
			rol oparand
			bld reg_status, 2
			in reg_Status, SREG
			andi reg_Status, 0b00000111
			bst reg_Status, 3
			rjmp mod_write_Absolute	;nur 8 statt 9 Takte!!



opcode_ROL_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X

			lsr reg_Status		; C-flag ins Carry
			rol oparand
			bld reg_status, 2
			in reg_Status, SREG
			andi reg_Status, 0b00000111
			bst reg_Status, 3
			rjmp mod_write_Absolute	;nur 8 statt 9 Takte!!





opcode_LSR:

opcode_LSR_accu:
			movw ZL, reg_PCL		; Z wieder als PC
			adiw SyncL, 2*MHz				;2
			lsr reg_A
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop

opcode_LSR_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP


	opc_LSR_ZP_1:
			lsr oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_ZP

opcode_LSR_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX
			lsr oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_ZP


opcode_LSR_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			andi reg_Status, 0b11111000


		opc_LSR_Abs_1:
			lsr oparand
			in temp, SREG
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_Absolute

opcode_LSR_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			andi reg_Status, 0b11111000

			lsr oparand
			in temp, SREG
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_Absolute





opcode_ROR:

opcode_ROR_accu:
			movw ZL, reg_PCL		; Z wieder als PC
			adiw SyncL, 2*MHz				;2
			lsr reg_Status
			ror reg_A
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop

opcode_ROR_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP


	opc_ROR_ZP_1:
			lsr reg_Status
			ror oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_ZP

opcode_ROR_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX
			lsr reg_Status
			ror oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_ZP


opcode_ROR_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute


		opc_ROR_Abs_1:
			lsr reg_Status
			ror oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_Absolute

opcode_ROR_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			lsr reg_Status
			ror oparand
			in temp, SREG
			lsl reg_Status					; V-Flag wieder herstellen
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp mod_write_Absolute

