;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************






read_Immediate:
			ld oparand, X+
			ijmp


; ********************************************************************************
; Ab hier:			Absolute, Absolute-X, Absolute-Y
; ********************************************************************************


read_Absolute:
			READ_RAMROM YL

			READ_RAMROM YH

		read_Abs_00:
			andi YH, 0b00011111

			tst YH
			breq read_Abs_1			; ZP-Zugriff
			cpi YH, ROMBASE
			brsh read_Abs_ROM
			cpi YH, IOBASE
			brlo read_Abs_RAM
			; hier msste fr IO synchronisiert werden
			; noch auf Ende IO abfragen und nach RAM verzweigen
			cpi YL, 0x80
			brsh read_Abs_RAM

			rcall Do_Sync
			adiw SyncL, MHz
			rjmp READ_IO

		read_Abs_RAM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			ld oparand, Y
			adiw SyncL, MHz
			;READ_RAMROM oparand
			ret
		read_Abs_ROM:
			movw reg_PCL, ZL
			movw ZL, YL
			lpm oparand, Z
			adiw SyncL, MHz
			movw ZL, reg_PCL
			ret

		read_Abs_1:
			mov YH, ZP_Highbyte
			ld oparand, Y
			ret


read_Absolute_Y:
			READ_RAMROM YL
			READ_RAMROM YH

			add YL, reg_Y
			brcc read_Abs_00
			adc YH, zero
			adiw SyncL, MHz
			rjmp read_Abs_00

read_Absolute_X:
			READ_RAMROM YL

			READ_RAMROM YH
			add YL, reg_X
			brcs read_Abs_00
			adc YH, zero
			adiw SyncL, MHz
			rjmp read_Abs_00




write_Absolute:
			READ_RAMROM YL
			READ_RAMROM YH

mod_write_Absolute:
			andi YH, 0b00011111

			tst YH
			breq write_Abs_1			; ZP-Zugriff
			; ab hier keine ZP: normal aus RAM lesen

			cpi YH, ROMBASE
			brsh write_Abs_ROM
			cpi YH, IOBASE
			brlo write_Abs_RAM
			; hier msste fr IO synchronisiert werden
			cpi YL, 0x80
			brsh write_Abs_RAM

			rcall Do_Sync
			adiw SyncL, MHz
			rjmp WRITE_IO
			
		write_Abs_RAM:
			st Y, oparand
			adiw SyncL, MHz
			ret
		write_Abs_ROM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			;lpm oparand, Z
			adiw SyncL, MHz

			rjmp main_loop
		write_Abs_1:
			;ab hier normal ZP
			mov YH, ZP_Highbyte
			st Y, oparand
			adiw SyncL, MHz
			rjmp main_loop

write_Absolute_Y:
			READ_RAMROM YL
			READ_RAMROM YH

			add YL, reg_Y
			brcc mod_write_Absolute
			adc YH, zero
			adiw SyncL, MHz

			rjmp mod_write_Absolute

write_Absolute_X:
			READ_RAMROM YL
			READ_RAMROM YH

			add YL, reg_X
			brcc mod_write_Absolute
			adc YH, zero
			adiw SyncL, MHz
			rjmp mod_write_Absolute






mod_write_Absolute_Syncless:
			adiw SyncL, MHz
			andi YH, 0b00011111
			tst YH
			breq write_Abs_1_Syncless			; ZP-Zugriff
			; ab hier keine ZP: normal aus RAM lesen

			cpi YH, ROMBASE
			brsh write_Abs_ROM_Syncless
			cpi YH, IOBASE
			brlo write_Abs_RAM_Syncless
			; hier msste fr IO synchronisiert werden
			cpi YL, 0x80
			brsh write_Abs_RAM_Syncless

			;rcall Do_Sync
			rjmp WRITE_IO
			
		write_Abs_RAM_Syncless:
			st Y, oparand
			ret
		write_Abs_ROM_Syncless:
			;movw reg_PCL, ZL
			;movw ZL, YL
			;lpm oparand, Z

			rjmp main_loop
		write_Abs_1_Syncless:
			;ab hier normal ZP
			mov YH, ZP_Highbyte
			st Y, oparand
			rjmp main_loop







; ********************************************************************************
; Ab hier:			ZeroPage, ZeroPage X-Ind, ZeroPage Y-Ind
; ********************************************************************************


read_ZP:
			READ_RAMROM YL
		read_ZP_1:
			;ab hier normal ZP
			mov YH, ZP_Highbyte
			ld oparand, Y
			ret

read_ZPX:
			READ_RAMROM YL
		read_ZPX_1:
			add YL, reg_X
			;ab hier normal ZP
			mov YH, ZP_Highbyte
			ld oparand, Y
			ret

read_ZPY:
			READ_RAMROM YL
		read_ZPY_1:
			add YL, reg_Y
			;ab hier normal ZP
			mov YH, ZP_Highbyte
			ld oparand, Y
			ret











write_ZP:
			READ_RAMROM YL
mod_write_ZPX:
mod_write_ZP:
			;ab hier normal ZP
			mov YH, ZP_Highbyte
			st Y, oparand
			rjmp main_loop

write_ZPX:
			READ_RAMROM YL
			add opbyte2, reg_X
			mov YH, ZP_Highbyte
			st Y, oparand
			rjmp main_loop


write_ZPY:
			READ_RAMROM YL
			add opbyte2, reg_Y
			mov YH, ZP_Highbyte
			st Y, oparand
			rjmp main_loop




















; ********************************************************************************
; Ab hier:			Indexed indirect
; ********************************************************************************





read_InX:
			READ_RAMROM YL
			;ld YL, X+
			mov YH, ZP_Highbyte
			ld opbyte3, Y

		read_InX_2:
			add opbyte3, reg_X

			mov YL, opbyte3;mov opbyte3, YL		???
			;mov YH, ZP_Highbyte

			ld opbyte2, Y

			inc YL
			;mov YL, opbyte3
			;mov YH, ZP_Highbyte
			ld temp2, Y							

			;Adresse in temp2 + opbyte2
			andi temp2, 0b00011111

			tst temp2
			breq read_InX_4_1		; ZP_Adresse!

	; hier RAM/ROM + IO
			mov YL, opbyte2
			cpi temp2, ROMBASE
			brsh read_InX_ROM
			cpi temp2, IOBASE
			brlo read_InX_RAM
			; hier msste fr IO synchronisiert werden
			cpi YL, 0x80
			brsh read_InX_RAM

			rcall Do_Sync
			adiw SyncL, MHz
			;mov YH, temp2
			rjmp READ_IO

		read_InX_RAM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			mov YH, temp2
			;mov YL, opbyte2
			ld oparand, Y
			adiw SyncL, MHz
			;READ_RAMROM oparand
			ret
		read_InX_ROM:
			movw reg_PCL, ZL
			;movw ZL, YL
			mov ZH, temp2
			mov ZL, opbyte2
			lpm oparand, Z
			movw ZL, reg_PCL
			adiw SyncL, MHz
			ret


		read_InX_4_1:
			;mov YL, opbyte2
			mov YH, ZP_Highbyte
			ld oparand, Y							; +++++++++++++++++++++++++++
			ret
			



; erstmal auslassen, sind nur illegale Ops












write_InX:
	; gilt ja eigentlich nur fr STA
	; trotzdem Daten in oparand, nicht nur reg_A
			;ld YL, X+
			READ_RAMROM YL
			; check auf 0+1
			mov YH, ZP_Highbyte
			ld opbyte3, Y

			add opbyte3, reg_X

			mov YL, opbyte3
			;mov YH, ZP_Highbyte
			ld opbyte2, Y

			inc YL
			;mov YL, opbyte3
			mov YH, ZP_Highbyte
			ld temp2, Y

			;Adresse in temp2 + oparand
			andi temp2, 0b00011111
			mov YL, opbyte2
			tst temp2
			breq write_InX_4_1		; ZP_Adresse!

			cpi temp2, ROMBASE
			brsh write_InX_ROM
			cpi temp2, IOBASE
			brlo write_InX_RAM
			; hier msste fr IO synchronisiert werden
			cpi YL, 0x80
			brsh write_InX_RAM

			rcall Do_Sync
			adiw SyncL, MHz
			;mov YH, temp2
			rjmp WRITE_IO

		write_InX_RAM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			mov YH, temp2
			;mov YL, opbyte2
			st Y, oparand
			adiw SyncL, MHz
			;READ_RAMROM oparand
			ret

		write_InX_ROM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			;mov ZH, temp2
			;mov ZL, opbyte2
			;lpm oparand, Z
			adiw SyncL, MHz
			ret


		write_InX_4_1:
			;mov YL, opbyte2
			mov YH, ZP_Highbyte
			st Y, oparand
			adiw SyncL, MHz
			rjmp main_loop







; ********************************************************************************
; Ab hier:			Indirect indexed
; ********************************************************************************








read_InY:
			;ld YL, X+
			READ_RAMROM YL
			mov YH, ZP_Highbyte

			ld opbyte3, Y

			inc YL
			;mov YL, opbyte2
			;mov YH, ZP_Highbyte
			ld temp2, Y

			add opbyte3, reg_Y
			brcc read_InY_3_0
			adiw SyncL, 2*MHz
			inc temp2
		read_InY_3_0:
			andi temp2, 0b00011111
			mov YL, opbyte3
			tst temp2
			breq read_InY_3_1
			; normaler Zugriff


			cpi temp2, ROMBASE
			brsh read_InY_ROM
			cpi temp2, IOBASE
			brlo read_InY_RAM
			; hier msste fr IO synchronisiert werden

			cpi YL, 0x80
			brsh read_InY_RAM

			rcall Do_Sync
			adiw SyncL, MHz
			;mov YH, temp2
			rjmp READ_IO

		read_InY_RAM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			mov YH, temp2
			;mov YL, opbyte3
			ld oparand, Y
			adiw SyncL, MHz
			;READ_RAMROM oparand
			ret
		read_InY_ROM:
			movw reg_PCL, ZL
			;movw ZL, YL
			mov ZH, temp2
			mov ZL, opbyte3
			lpm oparand, Z
			movw ZL, reg_PCL
			adiw SyncL, MHz
			ret


		read_InY_3_1:
			;mov YL, opbyte3
			mov YH, ZP_Highbyte
			ld oparand, Y
			ijmp










write_InY:
			;ld YL, X+
			READ_RAMROM YL
			mov YH, ZP_Highbyte
			ld opbyte3, Y

			inc YL
			mov YH, ZP_Highbyte
			ld temp2, Y

			add opbyte3, reg_Y
			brcc write_InY_3_0
			inc temp2
			adiw SyncL, MHz
		write_InY_3_0:
			andi temp2, 0b00011111
			mov YL, opbyte3
			tst temp2
			breq write_InY_3_1
			; normaler Zugriff

			cpi temp2, ROMBASE
			brsh write_InY_ROM
			cpi temp2, IOBASE
			brlo write_InY_RAM
			; hier msste fr IO synchronisiert werden
			cpi YL, 0x80
			brsh write_InY_RAM

			rcall Do_Sync
			adiw SyncL, MHz
			;mov YH, temp2
			rjmp WRITE_IO

		write_InY_RAM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			mov YH, temp2
			;mov YL, opbyte3
			st Y, oparand
			adiw SyncL, MHz
			;READ_RAMROM oparand
			rjmp main_loop
		write_InY_ROM:
			;movw reg_PCL, ZL
			;movw ZL, YL
			;mov ZH, temp2
			;mov ZL, opbyte3
			;lpm oparand, Z
			adiw SyncL, MHz
			rjmp main_loop


		write_InY_3_1:
			;mov YL, opbyte3
			mov YH, ZP_Highbyte
			st Y, oparand
			rjmp main_loop














